
# PM2 Team 02 Projekt 1 Racetrack
Racetrack is a pen and paper game that dates back to the early 1960s in this version of the game, the game is digitalized and the math behind it is done automatically rather than calculated by hand and the winner gets informed automatically as well.

The aim of the game is to finish the race faster than your opponent or win by being the only survivor in case the other cars crash.

In order to not crash you have to keep in mind the acceleration and other player's car to get to the finish line safely.
# Testing
#### All test can be run by the terminal command:
    gradlew test
# Initialization:
#### The game can be initialized by the terminal command:
    gradlew run
You will then be prompted to select a track file from the selection by entering the corresponding number.

#### For each car that is taking part in the race a strategy has to be chosen there are the following options:

+ Do not move Strategy
> This Strategy sets the car stationary, and it won't make any moves during the game staying at the start point indefinitely.
+ User Move Strategy
> The player is prompted for each move to make a choice the different choices you are able to take are as following:
> > 1=down-left <br> 2=down<br> 3=down-right<br> 4=left<br> 5=no acceleration<br> 6=right <br> 7=up-left<br> 8=up<br> 9=up-right<br> it is also possible to leave the game when it is your turn by entering 10
+ Move List Strategy
> For this strategy a predefined list of moves have to be given, the list may contain all allowed moves like mentioned in User Move Strategy
> > To create your own Move List strategy it needs to be located in /racetrack/moves and be named as *track_name*-car-*character_of_car*.txt and be a txt file.
+ Path Follow Move Strategy
> A list of points given in a txt file where on each lime a coordinate is placed like (X:24, Y:22) gets used to calculate a path which makes the car cross each point.
> > To create your own follow move strategy it needs to be located in /racetrack/moves and be named as *track_name*_points.txt and be a txt file.
+ Path Finder Strategy
> The pathfinder Strategy Calculates a route itself and follows it direction fully automatically.

The shown Track can be interpreted as following:<br>
'spaces' are part of the raceable track.<br>
'#' is a Wall<br>
'>,<,^,v' are finish line components<br>
'X' is shown if a car crashes at its crash location.<br>
And every other character represents a car.
> To create your own track it needs to be located inside /racetrack/tracks and be a txt file. 
### Determining a winner
The winner gets determined automatically. <br> The car that first passes the finish line (doing a complete round) is given the win, if all car except one crash the surviving car will be crowned as the winner.<br>The game will inform you of this, and you will have the option to quit the game or play another match.

## Branching Model
We choose a simple branching model where all starting features got a branch and where merged into the main branch, some branches who needed unfinished code to be completed where taken from the game branch but merged into the main at the end as well.<br> Since there was just one end product  we abstained from using a development branch and merges where done straight into main branch.<br>Commits which contain only documentation and doesn't change any functionality are committed directly into the Main branch.

## Class Diagramm
To create the best possible insight, all methods that are in the classes that we edited are shown completely. Including the private methods, since they can clearly be distinguished from the public ones through their prefix. <br>
However, the classes that were already given, i.e. not editable, are also in the class diagram for clarity, but the methods had been omitted since they can be found in the documentation, and the interfaces are just there for grading test purposes. <br><br>
![Classdiagram of this program](./Klassendiagramm.svg)

## GitHub Project
Our GitHub Project can be found here: [GitHubProject](https://github.zhaw.ch/PM2-IT21bWIN-ruiz-mach-krea/team02-AngryNerds-projekt1-racetrack/projects)
